<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>DrawFontManagerDefault (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DrawFontManagerDefault (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/DrawFontManagerDefault.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
               title="interface in org.apache.poi.sl.draw"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/sl/draw/DrawFreeformShape.html"
               title="class in org.apache.poi.sl.draw"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/sl/draw/DrawFontManagerDefault.html"
               target="_top">Frames</a></li>
        <li><a href="DrawFontManagerDefault.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.sl.draw</div>
    <h2 title="Class DrawFontManagerDefault" class="title">Class DrawFontManagerDefault</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.sl.draw.DrawFontManagerDefault</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd><a href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
                           title="interface in org.apache.poi.sl.draw">DrawFontManager</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">DrawFontManagerDefault</span>
extends java.lang.Object
implements <a href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
              title="interface in org.apache.poi.sl.draw">DrawFontManager</a></pre>
                <div class="block">Manages fonts when rendering slides.

                    Use this class to handle unknown / missing fonts or to substitute fonts
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManagerDefault.html#DrawFontManagerDefault--">DrawFontManagerDefault</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>java.awt.Font</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManagerDefault.html#createAWTFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-double-boolean-boolean-">createAWTFont</a></span>(java.awt.Graphics2D&nbsp;graphics,
                                    <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                       title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo,
                                    double&nbsp;fontSize,
                                    boolean&nbsp;bold,
                                    boolean&nbsp;italic)</code>
                                    <div class="block">Create an AWT font object with the given attributes</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                        title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManagerDefault.html#getFallbackFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">getFallbackFont</a></span>(java.awt.Graphics2D&nbsp;graphics,
                                    <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                       title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo)</code>
                                    <div class="block">In case the original font doesn't contain a glyph, use the
                                        returned fallback font as an alternative
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                        title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManagerDefault.html#getMappedFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">getMappedFont</a></span>(java.awt.Graphics2D&nbsp;graphics,
                                    <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                       title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo)</code>
                                    <div class="block">select a font to be used to paint text</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManagerDefault.html#mapFontCharset-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-java.lang.String-">mapFontCharset</a></span>(java.awt.Graphics2D&nbsp;graphics,
                                    <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                       title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo,
                                    java.lang.String&nbsp;text)</code>
                                    <div class="block">Map text charset depending on font family.</div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="DrawFontManagerDefault--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>DrawFontManagerDefault</h4>
                                <pre>public&nbsp;DrawFontManagerDefault()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getMappedFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMappedFont</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                        title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;getMappedFont(java.awt.Graphics2D&nbsp;graphics,
                              <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                 title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#getMappedFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">DrawFontManager</a></code></span>
                                </div>
                                <div class="block">select a font to be used to paint text</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#getMappedFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">getMappedFont</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
                                                title="interface in org.apache.poi.sl.draw">DrawFontManager</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>graphics</code> - the graphics context to request additional rendering
                                        hints
                                    </dd>
                                    <dd><code>fontInfo</code> - the font info object corresponding to the text run font
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the font to be used to paint text</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getFallbackFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getFallbackFont</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                        title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;getFallbackFont(java.awt.Graphics2D&nbsp;graphics,
                                <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                   title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#getFallbackFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">DrawFontManager</a></code></span>
                                </div>
                                <div class="block">In case the original font doesn't contain a glyph, use the
                                    returned fallback font as an alternative
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#getFallbackFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-">getFallbackFont</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
                                                title="interface in org.apache.poi.sl.draw">DrawFontManager</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>graphics</code> - the graphics context to request additional rendering
                                        hints
                                    </dd>
                                    <dd><code>fontInfo</code> - the font info object corresponding to the text run font
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the font to be used as a fallback for the original typeface</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="mapFontCharset-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>mapFontCharset</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;mapFontCharset(java.awt.Graphics2D&nbsp;graphics,
                                       <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                          title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo,
                                       java.lang.String&nbsp;text)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#mapFontCharset-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-java.lang.String-">DrawFontManager</a></code></span>
                                </div>
                                <div class="block">Map text charset depending on font family.<p>

                                    Currently this only maps for wingdings font (into unicode private use area)</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#mapFontCharset-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-java.lang.String-">mapFontCharset</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
                                                title="interface in org.apache.poi.sl.draw">DrawFontManager</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>graphics</code> - the graphics context to request additional rendering
                                        hints
                                    </dd>
                                    <dd><code>fontInfo</code> - the font info object corresponding to the text run font
                                    </dd>
                                    <dd><code>text</code> - the raw text</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>String with mapped codepoints</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="http://stackoverflow.com/questions/8692095">Drawing exotic fonts in a
                                        java applet</a>,
                                        <a href="../../../../../org/apache/poi/util/StringUtil.html#mapMsCodepointString-java.lang.String-"><code>StringUtil.mapMsCodepointString(String)</code></a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createAWTFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-double-boolean-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>createAWTFont</h4>
                                <pre>public&nbsp;java.awt.Font&nbsp;createAWTFont(java.awt.Graphics2D&nbsp;graphics,
                                   <a href="../../../../../org/apache/poi/common/usermodel/fonts/FontInfo.html"
                                      title="interface in org.apache.poi.common.usermodel.fonts">FontInfo</a>&nbsp;fontInfo,
                                   double&nbsp;fontSize,
                                   boolean&nbsp;bold,
                                   boolean&nbsp;italic)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#createAWTFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-double-boolean-boolean-">DrawFontManager</a></code></span>
                                </div>
                                <div class="block">Create an AWT font object with the given attributes</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html#createAWTFont-java.awt.Graphics2D-org.apache.poi.common.usermodel.fonts.FontInfo-double-boolean-boolean-">createAWTFont</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
                                                title="interface in org.apache.poi.sl.draw">DrawFontManager</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>graphics</code> - the graphics context to request additional rendering
                                        hints
                                    </dd>
                                    <dd><code>fontInfo</code> - the font info object corresponding to the text run font
                                    </dd>
                                    <dd><code>fontSize</code> - the font size in points</dd>
                                    <dd><code>bold</code> - <code>true</code> if the font is bold</dd>
                                    <dd><code>italic</code> - <code>true</code> if the font is italic</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the AWT font object</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/DrawFontManagerDefault.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/sl/draw/DrawFontManager.html"
               title="interface in org.apache.poi.sl.draw"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/sl/draw/DrawFreeformShape.html"
               title="class in org.apache.poi.sl.draw"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/sl/draw/DrawFontManagerDefault.html"
               target="_top">Frames</a></li>
        <li><a href="DrawFontManagerDefault.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
